import { SimpleAsyncCache, SimpleCache } from 'with-simple-caching';
import { NormalizeCacheValueMethod, SerializableObject } from '../../domain/NormalizeCacheValueMethod';
/**
 * a wrapper which augments a cache to add normalization on set and denormalization on get
 */
export declare const withNormalization: <T extends SerializableObject>(cache: SimpleCache<T>, { normalize, referenceSecondsUntilExpiration, }: {
    normalize: NormalizeCacheValueMethod;
    /**
     * the number of seconds until the referenced normalized values expire
     *
     * note
     * - this should be pretty long, since this simply garbage collects values after some duration since the last time a query set them
     * - in otherwords, this could invalidate query outputs earlier than when they should be, but can't produce stale responses
     */
    referenceSecondsUntilExpiration?: number | undefined;
}) => SimpleAsyncCache<T>;
