import { SimpleAsyncCache, SimpleCache } from 'with-simple-caching';
import { SerializableObject } from '../../domain/NormalizeCacheValueMethod';
/**
 * a utility which makes it easy to add normalization to caches which only persist string values
 *
 * specifically
 * - it serializes and deserializes values before setting to the cache
 */
export declare const withSerialization: <T extends SerializableObject = SerializableObject>(cache: SimpleCache<string>, { serialize, deserialize, }?: {
    serialize?: ((value: T | undefined) => string) | undefined;
    deserialize?: ((value: string) => T) | undefined;
}) => SimpleAsyncCache<T>;
