"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.withSerialization = void 0;
/**
 * a utility which makes it easy to add normalization to caches which only persist string values
 *
 * specifically
 * - it serializes and deserializes values before setting to the cache
 */
const withSerialization = (cache, { serialize = JSON.stringify, deserialize = JSON.parse, } = {}) => {
    return Object.assign(Object.assign({}, cache), { set: (key, value, options) => __awaiter(void 0, void 0, void 0, function* () { return cache.set(key, serialize(value), options); }), get: (key) => __awaiter(void 0, void 0, void 0, function* () {
            const found = yield cache.get(key);
            if (!found)
                return undefined;
            return deserialize(found);
        }) });
};
exports.withSerialization = withSerialization;
//# sourceMappingURL=withSerialization.js.map